      SUBROUTINE IAM2R(N,X,Y,Z,II,F0,F,A,B,C,H,V)                       IAM20010
         INTEGER II,N                                                   IAM20020
         REAL A,B,C,F,F0,H,V,X,Y,Z                                      IAM20030
         DIMENSION A(N),B(N),C(N),F(N),F0(N),H(N),II(N),V(N),X(N),      IAM20040
     1             Y(N),Z(N)                                            IAM20050
         INTEGER I,I0,I1,I2,IB,IE,IM,J,J0,L,N1,NN,NN1,NN2               IAM20060
         REAL A0,B0,FTI,Q,R,R1,T                                        IAM20070
       A(1) = 0.                                                        IAM20080
       B(1) = 0.                                                        IAM20090
       N1 = N - 1                                                       IAM20100
       DO 10 I = 1, N1                                                  IAM20110
          A(I+1) = A(I) + (X(I+1) - X(I))*(Y(I+1) + Y(I))/2.            IAM20120
          B(I+1) = B(I) + X(I)*(A(I+1) - A(I)) + (X(I+1) - X(I))**2*    IAM20130
     1             (Y(I) + 2.*Y(I+1))/6.                                IAM20140
   10  CONTINUE                                                         IAM20150
       DO 20 I = 1, N                                                   IAM20160
          F0(I) = X(I)*A(I) - B(I)                                      IAM20170
   20  CONTINUE                                                         IAM20180
       Q = A(N)                                                         IAM20190
       NN = 2                                                           IAM20200
       II(1) = 1                                                        IAM20210
       II(2) = N                                                        IAM20220
       H(1) = X(N) - X(1)                                               IAM20230
       F(1) = 0.                                                        IAM20240
       F(2) = F0(N)                                                     IAM20250
       V(1) = 0.                                                        IAM20260
       V(2) = Q                                                         IAM20270
   30  CONTINUE                                                         IAM20280
       R = 0.                                                           IAM20290
       NN1 = NN - 1                                                     IAM20300
       DO 40 J = 1, NN1                                                 IAM20310
          I0 = II(J)                                                    IAM20320
          I1 = I0 + 1                                                   IAM20330
          I2 = II(J+1)                                                  IAM20340
          DO 40 I = I1, I2                                              IAM20350
             T = (X(I) - X(I0))/H(J)                                    IAM20360
             FTI = F(J)*(1. - T)**2*(1. + 2.*T) + F(J+1)*T**2*(3. -     IAM20370
     1             2.*T) + H(J)*T*(1. - T)*(V(J)*(1. - T) - V(J+1)      IAM20380
     2             *T)                                                  IAM20390
             R1 = F0(I) - FTI                                           IAM20400
             IF (R1 .LE. R) GO TO 40                                    IAM20410
                IM = I                                                  IAM20420
                J0 = J + 1                                              IAM20430
                R = R1                                                  IAM20440
   40     CONTINUE                                                      IAM20450
          IF (R .EQ. 0.) GO TO 240                                      IAM20460
             DO 50 J = 1, J0                                            IAM20470
                Z(J) = B(J)                                             IAM20480
   50        CONTINUE                                                   IAM20490
             DO 60 L = J0, NN                                           IAM20500
                J = -L + NN + J0                                        IAM20510
                II(J+1) = II(J)                                         IAM20520
                Z(J+1) = B(J)                                           IAM20530
   60        CONTINUE                                                   IAM20540
             II(J0) = IM                                                IAM20550
             Z(J0) = 0.                                                 IAM20560
             NN = NN + 1                                                IAM20570
   70     CONTINUE                                                      IAM20580
          NN1 = NN - 1                                                  IAM20590
          DO 80 J = 1, NN1                                              IAM20600
             I1 = II(J)                                                 IAM20610
             I2 = II(J+1)                                               IAM20620
             H(J) = X(I2) - X(I1)                                       IAM20630
             F(J) = F0(I1)                                              IAM20640
   80     CONTINUE                                                      IAM20650
          F(NN) = F0(N)                                                 IAM20660
          V(NN) = Q                                                     IAM20670
          DO 90 J = 2, NN1                                              IAM20680
             A(J) = H(J-1)/(H(J-1) + H(J))                              IAM20690
             B(J) = H(J)/(H(J-1) + H(J))                                IAM20700
             C(J) = 3.*(A(J)*(F(J+1)-F(J))/H(J) + B(J)*(F(J) -          IAM20710
     1              F(J-1))/H(J-1))                                     IAM20720
   90     CONTINUE                                                      IAM20730
          C(NN-1) = C(NN-1) - A(NN-1)*V(NN)                             IAM20740
          B(2) = 2.                                                     IAM20750
          IF (NN .EQ. 3) GO TO 110                                      IAM20760
             DO 100 J = 3, NN1                                          IAM20770
                C(J) = C(J) - C(J-1)*B(J)/B(J-1)                        IAM20780
                B(J) = 2. - A(J-1)*B(J)/B(J-1)                          IAM20790
  100        CONTINUE                                                   IAM20800
  110     CONTINUE                                                      IAM20810
          V(NN-1) = C(NN-1)/B(NN-1)                                     IAM20820
          IF (NN .EQ. 3) GO TO 130                                      IAM20830
             NN2 = NN - 2                                               IAM20840
             DO 120 L = 2, NN2                                          IAM20850
                J = NN - L                                              IAM20860
                V(J) = (C(J) - A(J)*V(J+1))/B(J)                        IAM20870
  120        CONTINUE                                                   IAM20880
  130     CONTINUE                                                      IAM20890
          DO 140 J = 1, NN1                                             IAM20900
             A(J) = 12.*(F(J) - F(J+1))/H(J)**3 + 6.*(V(J) + V(J+1)     IAM20910
     1              )/H(J)**2                                           IAM20920
  140     CONTINUE                                                      IAM20930
          DO 150 J = 2, NN1                                             IAM20940
             B(J) = A(J) - A(J-1)                                       IAM20950
  150     CONTINUE                                                      IAM20960
          DO 160 J = 2, NN1                                             IAM20970
             IF (B(J) .LT. 0.) GO TO 180                                IAM20980
  160        CONTINUE                                                   IAM20990
             L = 1                                                      IAM21000
             DO 170 J = 2, NN1                                          IAM21010
                IF (B(J) .EQ. 0.) GO TO 170                             IAM21020
                   L = L + 1                                            IAM21030
                   II(L) = II(J)                                        IAM21040
                   B(L) = B(J)                                          IAM21050
  170        CONTINUE                                                   IAM21060
             NN = L + 1                                                 IAM21070
             II(NN) = N                                                 IAM21080
             GO TO 30                                                   IAM21090
  180     CONTINUE                                                      IAM21100
          T = 1.                                                        IAM21110
          DO 190 J = 2, NN1                                             IAM21120
             IF (B(J) .GE. 0.) GO TO 190                                IAM21130
                R = Z(J)/(Z(J) - B(J))                                  IAM21140
                IF (R .LT. T) T = R                                     IAM21150
  190     CONTINUE                                                      IAM21160
          L = 1                                                         IAM21170
          DO 230 J = 2, NN1                                             IAM21180
             IF (B(J)) 200, 210, 220                                    IAM21190
  200        CONTINUE                                                   IAM21200
             R = Z(J)/(Z(J) - B(J))                                     IAM21210
             IF (R .EQ. T) GO TO 230                                    IAM21220
                GO TO 220                                               IAM21230
  210        CONTINUE                                                   IAM21240
             IF (Z(J) .EQ. 0.) GO TO 230                                IAM21250
  220        CONTINUE                                                   IAM21260
             L = L + 1                                                  IAM21270
             II(L) = II(J)                                              IAM21280
             Z(L) = (1. - T)*Z(J) + T*B(J)                              IAM21290
  230     CONTINUE                                                      IAM21300
          NN = L + 1                                                    IAM21310
          II(NN) = N                                                    IAM21320
          GO TO 70                                                      IAM21330
  240     CONTINUE                                                      IAM21340
          Z(N) = 6.*(F(NN-1) - F(NN))/H(NN-1)**2 + (2.*V(NN-1) + 4.*    IAM21350
     1           V(NN))/H(NN-1)                                         IAM21360
          DO 260 J0 = 2, NN                                             IAM21370
             J = NN - J0 + 1                                            IAM21380
             I1 = II(J)                                                 IAM21390
             I2 = II(J+1)                                               IAM21400
             Z(I1) = 6.*(F(J+1) - F(J))/H(J)**2 - (4.*V(J) + 2.*        IAM21410
     1               V(J+1))/H(J)                                       IAM21420
             IB = I1 + 1                                                IAM21430
             IE = I2 - 1                                                IAM21440
             DO 250 I = IB, IE                                          IAM21450
                A0 = (Z(I2) - Z(I1))/(X(I2) - X(I1))                    IAM21460
                B0 = (Z(I1)*X(I2) - Z(I2)*X(I1))/(X(I2) - X(I1))        IAM21470
                Z(I) = A0*X(I) + B0                                     IAM21480
  250        CONTINUE                                                   IAM21490
  260     CONTINUE                                                      IAM21500
          IF (NN .EQ. N) GO TO 280                                      IAM21510
             NN1 = NN + 1                                               IAM21520
             DO 270 I = NN1, N                                          IAM21530
                II(I) = 0                                               IAM21540
  270        CONTINUE                                                   IAM21550
  280     CONTINUE                                                      IAM21560
          RETURN                                                        IAM21570
      END                                                               IAM21580
